﻿/// <reference path="jquery/jquery-1.5.2.js" />
/// <reference path="jquery-ui/jquery-ui-1.8.11.min.js" />
/// <reference path="jquery.contextmenu/jquery.contextmenu.js" />
/// <reference path="jquery.jstree/jquery.jstree.js" />
/// <reference path="jquery.swfobject/jquery.swfobject.1-1-1.min.js" />
/// <reference path="ui.dialogr/ui.dialogr.js" />

jQuery.fn.reverse = function () {
    return this.pushStack(this.get().reverse(), arguments);
};

function playDialogVideo(strTitle, video) {
    $("#dialogVideo").dialog({
        title: strTitle,
        width: 750,
        closeOnEscape: false,
        height: 650,
        modal: false,
        resizable: false,
        zIndex: 1000,
        open: function (event, ui) {
            var $loader = $("#loader");
            $(this).prepend($loader);
            $loader.css("display", "block");
            $.get(video)
                .complete(function (data) {
                    $loader.css("display", "none");
                    $('#flashVideo').flash({ swf: video, width: 700, height: 600 });
                })
                .error(function (data) {

                });
        },
        beforeClose: function (event, ui) {
            $('#flashVideo').flash().remove();
        }
    });
}

function showMessage(msg) {
    var $dlgMessage = $("#dlgMessage");
            
    $("div", $dlgMessage).html("<img src='images/alert.png' style='vertical-align:middle; float:left; margin-right:5px;' />" + msg);
    $dlgMessage.dialog("moveToTop");
    $dlgMessage.dialog("option", "position", "center");
    $dlgMessage.dialog("open");
}


function performAction(action, el, $liSelectedFolder) {
    if (action == "cut") {
        performCut(el, $liSelectedFolder);
    }
    else
    if (action == "copy") {
        performCopy(el, $liSelectedFolder);
    }
    else
    if (action == "paste") {
        performPaste($liSelectedFolder);
    }
    else
    if (action == "delete") {
        performDelete(el, $liSelectedFolder);
    }
    else
    if (action == "rename") {
        performRename(el, $liSelectedFolder);
    }
    else
    if (action == "create") {
        performCreate($liSelectedFolder);
    }
}

function clearClipboard() {
    $(".clipBoard")
            .removeClass("cut")
            .removeClass("copy")
            .removeClass("clipBoard"); 
}


function performCut(el, $liSelectedFolder) {
    var $el = $(el);
    if ($el.hasClass("selectFile")) {
        clearClipboard();       // Καθάρισε το παλιό clipBoard
        $el
            .addClass("clipBoard")
            .addClass("cut"); // Κάντο clipBoard cut
    }
}

function performCopy(el, $liSelectedFolder) {
    var $el = $(el);
    if ($el.hasClass("selectFile")) {
        clearClipboard();       // Καθάρισε το παλιό clipBoard
            
        $el
            .addClass("clipBoard")
            .addClass("copy");	// Κάντο clipBoard copy
    }
}

function $fileNameExists(fileName, $liSelectedFolder, $elIgnore) {
    // Στα div που έχουν name το li.id που ανήκουν, ψάξε να δεις αν
    // υπάρχει αρχείο με αυτό το όνομα
    var selector = "#content div[name='" + $liSelectedFolder.attr("id") + "']";
    if ($elIgnore != null)
        selector += ":not('#" + $elIgnore.attr("id") + "')";
     //selector += " span";

    var $files = $(selector).filter(function () {
        return ($.trim($("span", this).text()) == fileName);
    });
    return $files;
}

function makeFileCopy($liSelectedFolder, $file) {
    var $copied = $file.clone(true);
    var fileName = $("span", $file).text();
    $copied.attr("id", function (pos) {
        return this.id + "copy" + pos;
    });
    var $span = $("span", $copied)
    $copied.attr("name", $liSelectedFolder.attr("id"));

    var copiedName, name, ext;
    var numCopy = 1;
    // Σπάσε το όνομα αρχείου σε κυρίως όνομα και επέκταση
    var str = new String(fileName).toLowerCase();
    var i = str.lastIndexOf(".");
    if (i == -1) {
        name = str;
        ext = "";
    }
    else {
        name = str.slice(0, i);
        ext = str.slice(i);
    }
    // Ψάξε να βρεις για τον σωστό αριθμό αντιγράφου
    copiedName = name + "(" + numCopy + ")" + ext;
    while ($fileNameExists(copiedName, $liSelectedFolder, null).size() != 0) {
        numCopy++;
        if (numCopy < 100)
            copiedName = name + "(" + numCopy + ")" + ext;
        else {// Πάνω από 100 αντίγραφα ????????
            var now = new Date();
            copiedName = now.getTime() + ext;
        }
    }
    $span.text(copiedName);
    $("#content").append($copied);
    return $copied;
}


function performPaste($liSelectedFolder) {
    var $divClipBoard = $("#content .clipBoard");
    if ($divClipBoard.size() == 0)   // if clipboard empty, do nothing
        return;

    var fileName = $("span", $divClipBoard).text();
    var $parentFolder = $("#" + $divClipBoard.attr("name"));


    if ($liSelectedFolder.attr("id") == $parentFolder.attr("id")) {
        // Ο φάκελος προορισμού είναι ίδιος με τον πηγαίο
        if ($divClipBoard.hasClass("cut"))
            showMessage("Δεν μπορείς να κάνεις μετακίνηση στον ίδιο φάκελο!");
        else {
            var $copied = makeFileCopy($liSelectedFolder, $divClipBoard);
            $copied.addClass("selectFile");
            $divClipBoard.removeClass("selectFile");
            // Καθάρισε όλα τα στοιχεία με .clipBoard
            clearClipboard();
            $("#folders").jstree("deselect_node");
            $("#folders").jstree("select_node", $liSelectedFolder);
        }
        return;
    }
    else {
        // Υπάρχει ίδιο αρχείο στον φάκελο προορισμού;
        var $filesExists = $fileNameExists(fileName, $liSelectedFolder, null);
        if ($filesExists.size() != 0) {
            $("#msgFileExists").text("Υπάρχει ήδη αρχείο με όνομα " + fileName);
            var $dlgReplaceOrCopy = $("#dlgReplaceOrCopy");
            $($dlgReplaceOrCopy).dialog("moveToTop");
            $($dlgReplaceOrCopy).dialog("option", "position", "center");
            $($dlgReplaceOrCopy).dialog("option", "buttons",
                {
                    "Αντικατάσταση": function () {

                        $($dlgReplaceOrCopy).dialog("close");
                        $filesExists.addClass("selectFile");
                        if ($divClipBoard.hasClass("cut"))
                            $divClipBoard.remove();
                        else
                            $divClipBoard.removeClass("selectFile");
                        // Καθάρισε όλα τα στοιχεία με .clipBoard
                        clearClipboard();
                        $("#folders").jstree("deselect_node");
                        $("#folders").jstree("select_node", $liSelectedFolder);
                    },
                    "Αντίγραφο": function () {
                        $($dlgReplaceOrCopy).dialog("close");
                        var $copied = makeFileCopy($liSelectedFolder, $divClipBoard);
                        $copied.addClass("selectFile");
                        if ($divClipBoard.hasClass("cut"))
                            $divClipBoard.remove();
                        else
                            $divClipBoard.removeClass("selectFile");
                        // Καθάρισε όλα τα στοιχεία με .clipBoard
                        clearClipboard();
                        $("#folders").jstree("deselect_node");
                        $("#folders").jstree("select_node", $liSelectedFolder);
                    },
                    "Ακύρωση": function () {
                        $($dlgReplaceOrCopy).dialog("close");
                    }
                });
            $($dlgReplaceOrCopy).dialog("open");
        }
        else {
            if ($divClipBoard.hasClass("cut"))
                $divClipBoard.attr("name", $liSelectedFolder.attr("id"));
            else {
                if ($divClipBoard.hasClass("copy")) {
                    var $cloned = $divClipBoard.clone();
                    $cloned.attr("id", function (pos) {
                        return this.id + "_clone" + pos;
                    });
                    $cloned.attr("name", $liSelectedFolder.attr("id"));
                    $("#content").append($cloned);
                }
            }
            // Καθάρισε όλα τα στοιχεία με .clipBoard
            clearClipboard();
            $("#folders").jstree("deselect_node");
            $("#folders").jstree("select_node", $liSelectedFolder);
        }
    }
}

function performDelete(el, $liSelectedFolder) {
    var $el = $(el);
    if ($el.hasClass("selectFile")) {
        var $dlgConfirm = $("#dlgConfirm");
        $($dlgConfirm).dialog("moveToTop");
        $($dlgConfirm).dialog("option", "position", "center");
        $($dlgConfirm).dialog("option", "buttons",
            {
                "Ναι": function () {
                    var options = {};
                    $($dlgConfirm).dialog("close");
                    $el.effect("fade", options, "slow", function () {
                        $el.remove();
                    });
                },
                "Όχι": function () {
                    $($dlgConfirm).dialog("close");
                }
            }
        );
        $($dlgConfirm).dialog("open");
    }
}

function performRename(el, $liSelectedFolder) {
    var $el = $(el);
    if ($el.hasClass("selectFile")) {
        var $span = $("span", $el);
        var name = $span.text();
        name = $.trim(name);
        var $input = $("<input type='text' style='width:65px; height:10px; font-size:90%;' />");
        $input.val(name);
        $span.text("");
        $span.append($input);
        $input.focus().select()
            .blur(function () {
                var newName = $input.val();
                newName = $.trim(newName);
                if (newName == "") {
                    $(this).replaceWith(name);
                    return true;             // if newName is empty, do nothing
                }

                if (newName == name) {
                    $(this).replaceWith(name);
                    return true;             // name has not changed, do nothing
                }

                var regex = /[*?\\/<>:\"|]/;
                if (newName.search(regex) != -1) {
                    showMessage("Το όνομα δεν μπορεί να περιέχει κάποιον από τους παρακάτω χαρακτήρες:\n * ? < > : | \\ / \"");
                    $(this).replaceWith(name);
                    return true;
                }

                if ($fileNameExists(newName, $liSelectedFolder, $el).size() != 0) {
                    showMessage("Υπάρχει ήδη αρχείο με το όνομα : " + newName);
                    $(this).replaceWith(name);
                    return true;             
                }

                $(this).replaceWith(newName);

                // Ενημέρωσε το εικονίδιο
                var $img = $("img", $el);
                var str = new String(newName).toLowerCase();
                var i = str.lastIndexOf(".");
                if (i == -1)
                    $img.attr("src", "images/generic_icon.png");
                else {
                    var ext = str.slice(i);
                    if (ext == ".doc")
                        $img.attr("src", "images/doc_icon.png");
                    else
                        if (ext == ".xls")
                            $img.attr("src", "images/xls_icon.png");
                        else
                            if (ext == ".jpg")
                                $img.attr("src", "images/jpg_icon.png");
                            else
                                if (ext == ".mp3")
                                    $img.attr("src", "images/mp3_icon.png");
                                else
                                    if (ext == ".wav")
                                        $img.attr("src", "images/wav_icon.png");
                                    else
                                        $img.attr("src", "images/generic_icon.png");
                }
            });

    }
}


function performCreate($liSelectedFolder) {
    var $dlgCreate = $("#dlgCreate");
    $dlgCreate.dialog("moveToTop");
    $dlgCreate.dialog("option", "position", "center");
    $dlgCreate.dialog("option", "buttons",
        {
            "OK": function () {
                var newFolderName = new String($("#newFolderName").val());
                newFolderName = $.trim(newFolderName);
                var now = new Date();
                var newFolderID = now.getTime();
                if (newFolderName != "") {
                    var regex = /[*?\\/<>:\"|]/;
                    if (newFolderName.search(regex) != -1) {
                        showMessage("Το όνομα δεν μπορεί να περιέχει κάποιον από τους παρακάτω χαρακτήρες:\n * ? < > : | \\ / \"");
                        return false;
                    }
                    // Ψάξε να δεις αν υπάρχει ίδιο όνομα.
                    var $folderNames = $($liSelectedFolder).children("ul").children("li").children("a").filter(function () {
                        return $.trim($(this).text()) == newFolderName;
                    });
                    if ($folderNames.size() == 0) {             // Υπάρχει ίδιο όνομα φακέλου;
                        var $ul = $("ul:first", $liSelectedFolder);
                        if ($ul.size() <= 0) {
                            $ul = $("<ul></ul>");
                            $liSelectedFolder.append($ul);
                        }
                        var $li = $("<li><a href='#'>" + newFolderName + "</a></li>");
                        $li.attr("id", newFolderID);
                        $ul.append($li);
                        $("#folders").jstree("refresh", -1);
                        $("#folders").jstree("open_all", $ul);
                    }
                    else {
                        showMessage("Υπάρχει ήδη φάκελος με το όνομα : " + newFolderName);
                        return false;
                    }
                }
                $dlgCreate.dialog("close");
            },
            "Άκυρο": function () {
                $dlgCreate.dialog("close");
            }
        }
    );
    $dlgCreate.dialog("open");
}


$(document).ready(function () {

    var $liSelectedFolder = null;   // Το LI που επιλέχθηκε από το δέντρο

    $("#folders").jstree({
        "ui": {
            "select_limit": 1,
            "select_multiple_modifier": "ctrl",
            "selected_parent_close": "select_parent",
            "initially_select": ["phtml_1"]
        },
        "core": {
            "animation": 100
        },
        "themes": {
            "theme": "default",
            "dots": true,
            "icons": true,
            "url": "css/jquery.jstree/themes/default/style.css"
        },
        "plugins": ["themes", "html_data", "ui"/*, "themeroller"*/]
    })
    .bind("select_node.jstree", function (e, data) {
        var curLI = data.inst._get_node(data.rslt.obj);

        $liSelectedFolder = $(curLI);   // όρισε τον επιλεγμένο φάκελο

        $("#window_explorer").dialogr("option", "title", $.trim($(curLI).children("a:first").text()));

        // Κρύψε όλα τα αρχεία
        $("#content div").css("display", "none");

        // Καθάρισε την επιλογή, μόνο αν το κλικ to
        // ξεκίνησε το #content
        $("#content").bind("click", function (e) {
            if (e.target == this) {
                $("#content div").removeClass("selectFile");
                $(this).removeClass("hoverFile");
            }
        })
        // Το context menu όταν γίνεται δεξί κλικ πάνω στο 
        // content και όχι σε κάποιο div
        .contextMenu("myMenu1", {
            bindings: {
                'paste': function (el) {
                    performAction("paste", el, $liSelectedFolder);
                },
                'create': function (el) {
                    performAction("create", el, $liSelectedFolder);
                }
            },
            onShowMenu: function (e, menu) {
                // Disable cut
                $("#cut", menu).unbind("click");
                $("#cut", menu).unbind("mouseenter mouseleave");
                $("#cut", menu).css("color", "darkgray");
                $("#cut", menu).addClass("disabled");
                // Disable copy
                $("#copy", menu).unbind("click");
                $("#copy", menu).unbind("mouseenter mouseleave");
                $("#copy", menu).css("color", "darkgray");
                $("#copy", menu).addClass("disabled");
                // Disable delete
                $("#delete", menu).unbind("click");
                $("#delete", menu).unbind("mouseenter mouseleave");
                $("#delete", menu).css("color", "darkgray");
                $("#delete", menu).addClass("disabled");
                // Disable rename
                $("#rename", menu).unbind("click");
                $("#rename", menu).unbind("mouseenter mouseleave");
                $("#rename", menu).css("color", "darkgray");
                $("#rename", menu).addClass("disabled");

                if ($("div.clipBoard").size() <= 0) {
                    // Disable paste if clipBoard empty
                    $("#paste", menu).unbind("click");
                    $("#paste", menu).unbind("mouseenter mouseleave");
                    $("#paste", menu).css("color", "darkgray");
                    $("#paste", menu).addClass("disabled");
                }

                return menu;
            }
        });

        // αφαίρεσε όλα τα αντίστοιχα event από τα div
        $("#content div").unbind("click")
        .unbind("contextmenu")
        .unbind("mouseenter mouseleave");

        // Στα div που έχουν name το li.id που ανήκουν
        $("#content div[name='" + $liSelectedFolder.attr("id") + "']")
            .addClass("wrapword")
        // Αριστερό κλικ
            .bind("click", function (e) {
                $("#content div").removeClass("selectFile");
                $(this).removeClass("hoverFile");
                $(this).addClass("selectFile");
                //e.stopPropagation();
            })
        // Δεξί κλικ
            .bind("contextmenu", function (e) {
                $("#content div").removeClass("selectFile");
                $(this).removeClass("hoverFile");
                $(this).addClass("selectFile");
                //e.preventDefault();
                e.stopPropagation();
            })
        // Hover
            .hover(
                function () {
                    if (!$(this).hasClass("selectFile"))
                        $(this).addClass("hoverFile");
                },
                function () {
                    $(this).removeClass("hoverFile");
                }
            )
        // Δημιουργεί το pop up context menu για κάθε div  
            .contextMenu("myMenu1", {
                bindings: {
                    'cut': function (el) {
                        performAction("cut", el, $liSelectedFolder);
                    },
                    'copy': function (el) {
                        performAction("copy", el, $liSelectedFolder);
                    },
                    'paste': function (el) {
                        performAction("paste", el, $liSelectedFolder);
                    },
                    'rename': function (el) {
                        performAction("rename", el, $liSelectedFolder);
                    },
                    'delete': function (el) {
                        performAction("delete", el, $liSelectedFolder);
                    },
                    'create': function (el) {
                        performAction("create", el, $liSelectedFolder);
                    }
                },
                onShowMenu: function (e, menu) {
                    if ($("div.clipBoard").size() <= 0) {
                        // Disable paste if clipBoard empty
                        $("#paste", menu).unbind("click");
                        $("#paste", menu).unbind("mouseenter mouseleave");
                        $("#paste", menu).css("color", "darkgray");
                        $("#paste", menu).addClass("disabled");
                        //this.bindings["paste"] = null;
                    }
                    return menu;
                }
            })
            .css("display", "block");

    }); // bind("select_node.jstree" ....

    $("#folders").jstree("open_all", -1);


    $("#my_documents").bind("click", function () {
        if ($("#window_explorer").dialogr("isOpen") == false) {
            $("#window_explorer").dialogr("option", "width", 500);
            $("#window_explorer").dialogr("option", "height", 300);
            $("#window_explorer").dialogr("open");
            return false;
        }
    })
    // Hover
    .hover(
        function () {
            $(this).addClass("hoverFileDesktop");
        },
        function () {
            $(this).removeClass("hoverFileDesktop");
        }
    );


    $("#tabs-messages").tabs();

    $("#playCopy").button({
        text: false,
        icons: {
            primary: "ui-icon-play"
        }
    })
    .click(function () {
        playDialogVideo("Αντιγραφή φακέλων ή αρχείων", "videos/fakeloi_copy.swf");
    });

    $("#playCut").button({
        text: false,
        icons: {
            primary: "ui-icon-play"
        }
    })
    .click(function () {
        playDialogVideo("Μετακίνηση φακέλων ή αρχείων", "videos/fakeloi_cut.swf");
    });

    $("#playDelete").button({
        text: false,
        icons: {
            primary: "ui-icon-play"
        }
    })
    .click(function () {
        playDialogVideo("Διαγραφή φακέλων ή αρχείων", "videos/fakeloi_delete.swf");
    });

    $("#playRename").button({
        text: false,
        icons: {
            primary: "ui-icon-play"
        }
    })
    .click(function () {
        playDialogVideo("Μετονομασία φακέλων ή αρχείων", "videos/fakeloi_rename.swf");
    });

    $("#playCreate").button({
        text: false,
        icons: {
            primary: "ui-icon-play"
        }
    })
    .click(function () {
        playDialogVideo("Δημιουργία φακέλου", "videos/fakeloi_create.swf");
    });

    $("#dlgConfirm").dialog({
        modal: true,
        closeOnEscape: false,
        width: 300,
        height: 140,
        position: "center",
        autoOpen: false,
        resizable: false,
        stack: false,
        title: "Διαγραφή στοιχείου"
    });

    $("#dlgCreate").dialog({
        modal: true,
        closeOnEscape: false,
        width: 250,
        height: 150,
        position: "center",
        autoOpen: false,
        resizable: false,
        stack: false,
        title: "Δημιουργία φακέλου",
        open: function (event, ui) {
            $("#newFolderName").val("");
        }
    });

    $("#dlgReplaceOrCopy").dialog({
        modal: true,
        closeOnEscape: false,
        width: 400,
        height: 170,
        position: "center",
        autoOpen: false,
        resizable: false,
        stack: false,
        title: "Προειδοποίηση"
    });


    $("#window_explorer").dialogr({
        autoOpen: false,
        closeOnEscape: false,
        width: 500,
        height: 300,
        modal: false,
        stack: false
    });

    $("#dlgMessage").dialog({
        autoOpen: false,
        closeOnEscape: false,
        width: 350,
        height: 200,
        modal: true,
        stack: false,
        resizable: false,
        title: "Προσοχή",
        buttons: {
            "OK": function () {
                $("#dlgMessage").dialog("close");
            }
        }
    });


});
